// SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
//
// SPDX-License-Identifier: GPL-3.0-or-later

#ifndef DPCDEFINE_H
#define DPCDEFINE_H

namespace DPCDefine {
static constexpr char InterfaceService[] { "com.deepin.filemanager.daemon" };
static constexpr char InterfacePath[] { "/com/deepin/filemanager/daemon/AccessControlManager" };
static constexpr char InterfaceInterface[] { "com.deepin.filemanager.daemon.AccessControlManager" };

static constexpr char SigPwdChanged[] { "DiskPasswordChanged" };
static constexpr char FuncChangePwd[] { "ChangeDiskPassword" };
static constexpr char SigPwdChecked[] { "DiskPasswordChecked" };

// error code of change disk password
enum DPCErrorCode {
    NoError = 0,
    AuthenticationFailed,
    InitFailed,
    DeviceLoadFailed,
    PasswordChangeFailed,
    PasswordWrong,
    AccessDiskFailed,   // Unable to get the encrypted disk list
    PasswordInconsistent   // Passwords of disks are different
};

} // namespace DPCDefine

#endif // DPCDEFINE_H
