/*
 * Copyright (C) 2023 Uniontech Software Technology Co., Ltd.
 *
 * Author:     liuzhangjian<liuzhangjian@uniontech.com>
 *
 * Maintainer: zhengyouge<zhengyouge@uniontech.com>
 *             liuzhangjian<liuzhangjian@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef EETRUSTEMBLEMPLUGIN_H
#define EETRUSTEMBLEMPLUGIN_H

#include <emblemicon/dfmextemblemiconplugin.h>
#include <emblemicon/dfmextemblem.h>

class EetrustEmblemPlugin : public DFMEXT::DFMExtEmblemIconPlugin
{
public:
    explicit EetrustEmblemPlugin();

    /**
     * @brief locationEmblemIcons 设置角标
     * @param fileUrl 当前绘制的文件路径
     * @param systemIconCount 当前文件已存在的系统角标个数
     * @return 用户自定义角标
     */
    dfmext::DFMExtEmblem locationEmblemIcons(const std::string &filePath, int systemIconCount);

private:
    void init();

private:
    typedef int (*GetIncoNameFunc)(char *, char *);
    GetIncoNameFunc getIconNameFunc { nullptr };
};

#endif // EETRUSTEMBLEMPLUGIN_H
